/'
 ' Written in FreeBASIC (visit www.freebasic.net for the compiler)
 '
 ' Copyright (C) 2010-2014 Challenge Space Yard.
 '
 ' A windows user can decide whether to use a console box (default)
 ' or not (by supplying with -s gui)
 '
 ' Don't forget to include the corrosponding module mapcUI.rc when
 ' compiling if you want to use the included icon.
 '/
#Include "mapcUI.bi"
windowtitle Title
if FileExists("FS.ini") then
	screen 19,24,2,GFX_FULLSCREEN
else
	screen 19,24,2,GFX_WINDOWED
end if
if FileExists("mapcUI.ini") then
	open "mapcUI.ini" for input as #1
	input #1, BaseMapc
	input #1, BaseData
	close #1
	if BaseMapc = "" then
		BaseMapc = "."
	end if
	if BaseData = "" then
		BaseData = "./"
	end if
else
	BaseMapc = "."
	BaseData = "./"
end if
if FileExists(BaseMapc+"/"+Compiler) then
	chdir(BaseMapc)
	CustomFilter = BaseData 
	Usable = 1
end if
SelectedFile = 1
screenset 1,0
do
	MapCount(1) = MapCount(0)
	MapCount(0) = 0
	DirReference = ""
	for CFID as ushort = 1 to len(CustomFilter)
		#IFDEF __FB_WIN32__
			if mid(CustomFilter,CFID,1) = "/" OR _
				mid(CustomFilter,CFID,1) = "\" then
				DirReference = left(CustomFilter,CFID) 
			end if
		#ELSE
			if mid(CustomFilter,CFID,1) = "/" then
				DirReference = left(CustomFilter,CFID) 
			end if
		#ENDIF
	next CFID
	color rgb(255,255,255),rgb(0,0,0)
	cls
	color rgb(0,255,255)
	print Title;
	if CheckAttrib = "" then
		print " - No attributes being scanned"
	else
		print " - Scanned for attribute ";quote(CheckAttrib)
	end if
	color rgb(255,255,255)
	if Usable = 1 then
		print word_wrap("Instructions: Use this interface to manage and compile "+_
			"levels and holes for Neverball and Neverputt. Filter may be adjusted "+_
			"to list only certain maps, and/or change directories. Additional commands below.",100)
		print
		color rgb(0,255,255)
		locate 7,1
		print "Available levels (";CustomFilter;"*.map)"
		print "File                        Map date     Compile date   Attributes scanned   Status"
		MapFile = Dir(CustomFilter+"*.map", fbNormal)
		while len(MapFile) > 0
			BaseFile = left(MapFile,len(MapFile)-4)
			SolFile = BaseFile + ".sol"
			if CheckAttrib < > "" then
				CacheFile = "." + BaseFile + "-" + CheckAttrib + ".dat"
			end if
			MapCount(0) += 1
			if abs(MapCount(0)-SelectedFile) < 13 OR ((MapCount(0) < = 25 AND SelectedFile < 13) OR (abs(MapCount(0)-MapCount(1)) < 25 AND SelectedFile > MapCount(1) - 13)) then
				if SelectedFile = MapCount(0) then
					ActiveFile = DirReference+MapFile
					color ,rgb(0,0,128)
				else
					color ,rgb(0,0,0)
				end if
				IDateTime(0) = FileDateTime(DirReference+MapFile)
				IDateTime(1) = FileDateTime(DirReference+SolFile)
				if CheckAttrib < > "" then
					IDateTime(2) = FileDateTime(DirReference+CacheFile)
					if FileExists(DirReference+CacheFile) = 0 OR IDateTime(2) < IDateTime(0) then
						AttribCount = test_map(MODE_ATTRIB_CHECK,DirReference+MapFile)
						open DirReference+CacheFile for output as #2
						print #2, AttribCount
						close #2
					else
						open DirReference+CacheFile for input as #2
						input #2, AttribCount
						close #2
					end if
				end if
				if InType = FunctionTwo AND Phase = 1 then
					test_map(MODE_PUTT_RADII,DirReference+MapFile)
					InType = FunctionTwo
					exec(Compiler,DirReference+MapFile+" data")
				elseif InType = FunctionThree AND IDateTime(1) < IDateTime(0) AND Phase = 1 then
					test_map(MODE_PUTT_RADII,DirReference+MapFile)
					InType = FunctionThree
					exec(Compiler,DirReference+MapFile+" data")
				end if
				if FileExists(DirReference+SolFile) then
					color rgb(255,255,255)
					'            File                        Map date     Compile date   Angle attributes   Status
					print using "\                      \    ##/##/####    ##/##/####    ";_
						BaseFile;_
						Month(IDateTime(0));Day(IDateTime(0));Year(IDateTime(0));_
						Month(IDateTime(1));Day(IDateTime(1));Year(IDateTime(1));
					color rgb(255,255,0)
					'                    Attributes scanned
					if CheckAttrib = "" then
						print           "  Not applicable     ";
					else
						if AttribCount = 1 then
							print       "       1 instance    ";
						else
							print using " ###,### instances   ";AttribCount;
						end if
					end if
					if InType = FunctionTwo then
						color rgb(255,255,0)
						print "Updating level..."
						if SelectedFile = MapCount(0) then
							RMessage = "Selected level is being updated."
							Legal = 0
						end if
					elseif IDateTime(1) > = IDateTime(0) then
						color rgb(0,255,0)
						print "Level up-to-date"
						if SelectedFile = MapCount(0) then
							RMessage = "Selected level is already up-to-date. You may recompile by pressing the ENTER key."
							Legal = 1
						end if
					else
						if InType = FunctionThree then
							color rgb(255,255,0)
							print "Updating level..."
							if SelectedFile = MapCount(0) then
								RMessage = "Selected level is being updated."
								Legal = 0
							end if
						else
							color rgb(255,96,96)
							print "Level outdated"
							if SelectedFile = MapCount(0) then
								RMessage = "Selected level is presently outdated. You should recompile by pressing the ENTER key."
								Legal = 1
							end if
						end if
					end if
				else
					color rgb(255,255,255)
					'            File                        Map date     Compile date   Status
					print using "\                      \    ##/##/####    --/--/----    ";_
						BaseFile;Month(IDateTime(0));Day(IDateTime(0));Year(IDateTime(0));
					'                    Attributes scanned
					color rgb(255,255,0)
					if CheckAttrib = "" then
						print           "  Not applicable     ";
					else
						if AttribCount = 1 then
							print       "       1 instance    ";
						else
							print using " ###,### instances   ";AttribCount;
						end if
					end if
					if InType = FunctionTwo OR InType = FunctionThree then
						color rgb(255,255,0)
						print "Compiling level..."
						if SelectedFile = MapCount(0) then
							RMessage = "Selected level is being compiled."
							Legal = 0
						end if
					else
						color rgb(255,96,96)
						print "Needs to be compiled"
						if SelectedFile = MapCount(0) then
							RMessage = "Level has never been compiled yet. You should compile by pressing the ENTER key."
							Legal = 1
						end if
					end if
				end if
			end if
			MapFile = dir()
		wend
		if MapCount(0) = 0 then
			RMessage = "No map files exist. Adjust your filter, or make a new level/hole."
		end if
		locate 34,1
		color rgb(0,255,255),rgb(0,0,0)
		if MapCount(0) > 0 then
			print MapCount(0);" map files found"
		end if
		locate 35,1
		color rgb(255,0,255)
		print word_wrap(RMessage,100)
		color rgb(255,255,255)
		print word_wrap("<ESC> Leave mapcUI, <F2> Compile all, <F3> Compile outdated, <F4> Scan attribute, <DEL> Reset cache",100)
		screencopy
		do
			sleep 5
			if InType = FunctionTwo OR InType = FunctionThree then
				if Phase = 0 then
					Phase = 1
					exit do
				else
					Phase = 0
					InType = chr(255)
					exit do
				end if
			end if
			MassUpdate = 0
			InType = inkey
		loop until InType < > ""
		if InType = FunctionFour then
			screenset 0,0
			locate 37,1
			print space(100);
			locate 37,1
			input ;"Which attribute do you wish to check across your maps";CheckAttrib
			screenset 1,0
		elseif InType = DeleteKey then
			for CFID as ushort = 1 to len(CustomFilter)
				#IFDEF __FB_WIN32__
					if mid(CustomFilter,CFID,1) = "/" OR _
						mid(CustomFilter,CFID,1) = "\" then
						DirReference = left(CustomFilter,CFID) 
					end if
				#ELSE
					if mid(CustomFilter,CFID,1) = "/" then
						DirReference = left(CustomFilter,CFID) 
					end if
				#ENDIF
			next CFID
			CacheFile = Dir(CustomFilter+".*.dat", fbNormal OR fbHidden)
			while len(CacheFile) > 0
				kill(DirReference+CacheFile)
				CacheFile = Dir()
			wend
		elseif InType = UpArrow AND SelectedFile > 1 then
			SelectedFile -= 1
		elseif InType = DownArrow then
			SelectedFile += 1
			if SelectedFile > MapCount(0) then
				SelectedFile = MapCount(0)
			end if
		elseif InType = PageUp then
			if SelectedFile > 24 then
				SelectedFile -= 24
			else
				SelectedFile = 1
			end if
		elseif InType = PageDown then
			SelectedFile += 24
			if SelectedFile > MapCount(0) then
				SelectedFile = MapCount(0)
			end if
		elseif InType = Backspace then
			CustomFilter = left(CustomFilter,len(CustomFilter)-1)
			SelectedFile = 1
		elseif InType > = chr(32) AND InType < = chr(126) then
			CustomFilter += InType
			SelectedFile = 1
		elseif InType = EnterKey AND Legal = 1 then
			test_map(MODE_PUTT_RADII,ActiveFile)
			exec(Compiler,ActiveFile+" data")
		elseif InType = FunctionTwelve then
			bsave("shot.bmp",0)
		elseif InType = EscapeKey OR InType = XBox then
			exit do
		end if
	else
		print word_wrap("NOTICE: In order to use mapcUI, you need to locate and map the compiler directory. Press ENTER to locate now.",100)
		screencopy
		sleep 10
		InType = inkey
		if InType = EnterKey then
			screenset 0,0
			input "Enter Neverball directory: ",BaseMapc
			if FileExists(BaseMapc+"/"+Compiler) then
				print "If your levels are in a different directory, you may map that directory as well."
				input "Enter base level directory",BaseData
				
				Usable = 1
				open "mapcUI.ini" for output as #1
				print #1, BaseMapc
				print #1, BaseData
				close #1
				chdir(BaseMapc)
			end if
			screenset 1,0
		elseif InType = EscapeKey OR InType = XBox then
			exit do
		end if
	end if
loop
