#include "fbgfx.bi"
#include "vbcompat.bi"
using FB
#include "WordWrap.bi"
const Title = "Neverball Map Compiler UI (mapcUI) 0.15"
const UpArrow = chr(255,72)
const DownArrow = chr(255,80)
const PageUp = chr(255,73)
const PageDown = chr(255,81)
const FunctionTwo = chr(255,60)
const FunctionThree = chr(255,61)
const FunctionFour = chr(255,62)
const FunctionTwelve = chr(255,134)
const DeleteKey = chr(255,83)
const XBox = chr(255,107)
const EscapeKey = chr(27)
const EnterKey = chr(13)
const Backspace = chr(8)
#IFDEF __FB_WIN32__
const Program = "mapcUI.exe"
const Compiler = "mapc.exe"
#ELSE
const Program = "mapcUI"
const Compiler = "mapc"
#ENDIF
dim as string BaseMapc, BaseData, DirReference, MapFile, BaseFile, SolFile, _
	CacheFile, ActiveFile, CustomFilter, RMessage
dim as ubyte Usable, Legal, Phase
dim as uinteger MapCount(1), SelectedFile, AttribCount
dim as longint SaveScore
dim as double IDateTime(2)
dim shared as byte MassUpdate
dim shared as string InType, CheckAttrib
enum ModeCollection
	MODE_PUTT_RADII
	MODE_ATTRIB_CHECK
end enum 
function quote(Text as string) as string
	return chr(34)+Text+chr(34)
end function
function test_map(Mode as ubyte, Filename as string) as integer
	dim as string TestString
	select case Mode
		case MODE_PUTT_RADII
			/'
			 ' Tests the MAP file for outdated Neverputt goal radii
			 '
			 ' Asks the user whether to update it for a single map, or
			 ' to apply to every map involved in the mass compilation.
			 '/
			dim as ubyte NeedsUpdate, ApplyUpdate
			open Filename for input as #1
			do
				line input #1, TestString
				if TestString = quote("radius")+" "+quote("0.125") then
					NeedsUpdate = 1
					exit do
				end if
			loop until eof(1)
			close #1
			if NeedsUpdate then
				if MassUpdate = 1 then
					ApplyUpdate = 1
				else
					color ,rgb(0,0,0)
					locate 36,1
					print word_wrap("Old Neverputt goal radii detected for "+Filename+". Update 0.125 to 0.1375? (Y/N/All)",100);
					screencopy
					do
						InType = inkey
						if InType = "y" then
							ApplyUpdate = 1
							exit do
						elseif InType = "a" then
							ApplyUpdate = 1
							MassUpdate = 1
							exit do
						end if
					loop until InType = "n"
				end if
				if ApplyUpdate then
					name(Filename,Filename+".bak")
					open Filename+".bak" for input as #1
					open Filename for output as #2
					do
						line input #1, TestString
						if TestString = quote("radius")+" "+quote("0.125") then
							print #2, quote("radius")+" "+quote("0.1375")
						else
							print #2, TestString
						end if
					loop until eof(1)
					close #1, #2
				end if
			end if
			return 0
		case MODE_ATTRIB_CHECK
			/'
			 ' Tests the MAP file for a specific attribute
			 '/
			dim as ubyte AngleCount
			open Filename for input as #1
			do
				line input #1, TestString
				if left(TestString,len(CheckAttrib)+2) = quote(CheckAttrib) then
					AngleCount += 1
				end if
			loop until eof(1)
			close #1
			return AngleCount
	end select
end function
